require "down_universe/version"
require "safe_shell"

module DownUniverse
  module Downloadable
    
    # Public: Downloads a given HTTP url with 'wget'.
    #
    # url - The url to be downloaded. That should respond to to_str.
    # output - Name and path of the output file.
    # user - set both ftp and http user(Optional).
    # password - set both ftp and http password(Optional).
    #
    # Returns boolean
    #
    # Examples
    #
    # http_download('http://test.com/som_file.iso', '/Users/test/file.iso')
    # # => true
    #
    # http_download('http://test.com/som_file.iso', '/Users/test/file.iso')
    # # => false
    def http_download(url, output, user=nil, password=nil)
      command = "wget -O #{output}"
      command += " --user=#{user}" unless user.nil?
      command += " --password=#{password}" unless password.nil?
      command += " #{url.to_str}"
      SafeShell.execute! command
    end
  end
end